% Compute analytical invariant of menu cost model  

%compute parameters of the density  of price gaps, p
%phi(p) = phi_1(p) if p<phat_ss; phi(p) = phi_2(p) if p>=phat_ss;
%phi_1(p) = Ad(1) + Ad(2) * exp(kk*p);
%phi_2(p) = Ad(3) + Ad(4) * exp(kk*p);


%  Now solve the 4 equation system to determine the 4 constants Ad(i) using
%  equations  outlined in the notes (kk is our phi in the notes)

kk = (gamma-mu)/(sigma^2/2);

% write system as Bd * Ad = Cd  and solve for Ad = Bd \ Cd  
Bd = zeros(4,4);
Bd(1,1) = 1;
Bd(1,2) = exp(kk*low_p_ss);
Bd(2,3) = 1;
Bd(2,4) = exp(kk*high_p_ss);
Bd(3,1) = 1;
Bd(3,2) = exp(kk*phat_ss);
Bd(3,3) = -1;
Bd(3,4) = -exp(kk*phat_ss);
Bd(4,1) = phat_ss-low_p_ss;
Bd(4,2) = (exp(kk*phat_ss)-exp(kk*low_p_ss))/kk;
Bd(4,3) = high_p_ss-phat_ss;
Bd(4,4) = (exp(kk*high_p_ss)-exp(kk*phat_ss))/kk;

Cd = zeros(4,1);
Cd(4,1) = 1;

% solve system  for Ad
Ad = Bd \ Cd;
A1= Ad(1);
B1= Ad(2);
A2= Ad(3);
B2= Ad(4);

%plot density
p_gg = low_p_ss:0.001:high_p_ss;
phi_p = zeros(length(p_gg),1);
for ii=1:length(p_gg),
    if p_gg(ii)<phat_ss,
    phi_p(ii) = A1+ B1 * exp(kk*p_gg(ii));
    else
    phi_p(ii) = A2+ B2 * exp(kk*p_gg(ii));
    end
end

% figure(3)
% plot(p_gg,phi_p)

%Find the vector of price gaps representative of the invariant distribution
V_p = zeros(N_sim,1);
phi_0=zeros(N_sim,1);
pct_1     = cumsum(ones(N_sim,1)/N_sim);
for ii=1:N_sim,
    if ii==1,
        V_p(ii)  = fzero(@(p) pct_1(ii) - fun_Phi(Ad,p,low_p_ss,high_p_ss,phat_ss,kk),low_p_ss);
        phi_0(ii)= pct_1(ii);
    else
        V_p(ii)  = fzero(@(p) pct_1(ii) - fun_Phi(Ad,p,low_p_ss,high_p_ss,phat_ss,kk),V_p(ii-1));
        phi_0(ii)= pct_1(ii)-pct_1(ii-1);
    end
end

