%  THIS CODE COMPUTES THE VALUE FUNCTION FOR A MENU COST PROBLEM WHERE THE OBJECTIVE
%  FUNCTION IS NON-QUADRATIC (WARN:  the CODE could be simplified ;  THIS version has LEFTOVERS FROM previous CODES )

% define params (all rates are per year)
global rho sigma  psi B quadlim mu p_g  PP delta epsilon gamma eta

%  Extreme of integration
quadlim  =  6;

disp('  ');
disp(' SOLVING the NON-LINEAR MODEL  with  adjustment cost ( psi>0 );  allows for drift');
disp('  ');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 

% Compute exact solution of problem with quadratic objectives to be used as a guess
% ( 5 equation   system see the notes  )
[p_dw,phat,p_up,z1,z2,CC] = fct_solve_MC(B,rho,sigma,mu,psi);


% Next use the previous approximate solution to solve the problem for the exact return function (non quadratic)
p_g = linspace(p_dw*1.5,p_up*1.5, 50);

[ V ] =  fct_V(p_g,B,rho,sigma,mu,z1,z2,CC,phat,p_dw,p_up,psi);

v_bar_ini   = (1/rho - V )  ;
vhat_s      = (1/rho -min(V)- psi);  % guess value function level outside inaction range (scalar)

% This is the spline of vbar, the max between vbar and vhat is taken inside the va fct
PP  = spline((p_g), v_bar_ini);

% Value function  iteration (CONTROLS)
indx_opt1        = 1  ;    % counter to decide when to perform the FIRST policy optimization
vf_maxit         = 600;    % max # of vf iteration
opt_step         = 5  ;    % optimize every "opt_step" iterations
stop_tau         = 5  ;    % stops searching for taubar after stop_tau grid points at tau=0 (tau_min)
tau_optimizer    = 0  ;    % use minimizer for taubar if tau_optimizer > 0 (otherwise grid search)
vfdisp_step      = 5 ; % display output every vfdisp_step iteration

warning off; % disactivates minimizers warnings


% Initial guess form quadratic problem 
vbar     =  v_bar_ini   ; 
vhat = vhat_s* ones(1,length(v_bar_ini));
v_g      =   max (vbar , vhat );

% Initial guess solution
p_hat =  phat;

% initialize bunch of indicators
crit_vf = 1; crit_tau = 1; crit_phat=1;  crit_pstar = 1; vf_it =  1 ;% if using a while criterion
std_taubar = 1; max_taubar = 1; crit_std_taubar = 1; crit_max_taubar = 1; indx_opt=indx_opt1;
first_iteration = 1; vfdisp=1; % output display

% BELLMAN EQ ITERATION 
% KEY HERE IS TO CHOOSE PHAT - NOT EQUAL TO ZERO AS IN SYMMETRIC CASE
while (crit_vf > 1e-4  ||  crit_phat > 1e-4 ) && vf_it < vf_maxit
    
    if vf_it == indx_opt || first_iteration == 1 
        % when true, then do policy optimization (otherwise just iterate a given policy)
        %vf_it
        
        % Compute vbar (restricted value function) for high ptilde:
        for i=1:length(p_g)
            % for each node in p_g compute max rhs w.r.t. tau (elements in t_g)
            p = p_g(i);
            vbar(i) = fct_vbar(dt,PP,vhat_s,p);
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
%        LB = (-2*mu) ; UB = (2*mu)  ;  bad if mu=0 .... ah ah ! 
        LB = -0.05 ; UB = 0.05  ;
          options = optimset('fmincon');
        [p_cdt,vhat_cdt] = fmincon(@(p_hat) -fct_vhat(dt,PP,vhat_s,p_hat),0.005,[],[],[],[],LB,UB,[],optimset(options,'TolX',1e-005','TolFun',1e-005,'Display','off'));
        vhat_s = -vhat_cdt;
        
        p_hat_old=p_hat;
        p_hat = p_cdt;
        crit_phat = norm(p_hat - p_hat_old);
        disp(['crit p-hat = ',num2str(crit_phat )]);
        crit_phat_history(1 + (indx_opt-indx_opt1)/opt_step ) = crit_phat;
        
        
        for i = 1:length(p_g)
            p = p_g(i);
            vhat(i) = vhat_s ;
            vbar(i) = fct_vbar(dt,PP,vhat_s,p) ;
        end% for i (A loop)
        
        indx_opt = indx_opt + opt_step;
        first_iteration = 0 ;
        
    else
   % Otherwise (i.e.  vf_it != indx_opt), just iterate the vf using previously determined policy rule
        
        vhat_s =  fct_vhat(dt,PP,vhat_s,p_hat);
        
        for i = 1:length(p_g)
            p = p_g(i);
            vhat(1,i) = vhat_s;
            vbar(1,i) = fct_vbar(dt,PP,vhat_s,p) ;
        end% for i (A loop)
        
    end % if vf_it ==indx_opt  ;
    
    v_g_old = v_g;
    v_g = max(vhat,vbar);
    % Update value function
    PP = spline(p_g,vbar);
    
    % record keeping
    vbar_history(vf_it,:)   = vbar;
    vhat_history(vf_it,:)   = vhat;
    vf_history(vf_it,:)     = v_g;
    phat_history(vf_it,:)   = p_hat;
    
    crit_vf = norm( (v_g - v_g_old)./v_g_old );
    crit_vf_history(vf_it) =   crit_vf ;
    
    if vf_it == vfdisp
        disp(['Done Iteration : ',num2str(vf_it),' ; crit_vf :',num2str(crit_vf)]);
        disp(['vf level: max V(p):  ', num2str(max(v_g ))]);
        disp(['  p_hat =  ' , num2str(p_hat)]);
        vfdisp = vfdisp + vfdisp_step  ;
    end
    
    vf_it = vf_it+1;
    % % save results
end %  (value function iteration)
%toc


% disp(' finished VF iteration ')
% compute statistics from the steady state distribution
vhat_ss      = vhat(1);
vbar_ss      = vbar;
phat_ss      = p_hat;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Obtain inaction region
p_g_fine = min(p_g):0.001:max(p_g);
vdif_n=[];
vdif_ss=[];
for i=1:length(p_g_fine),
    vdif_ss(i)   = ppval(PP,p_g_fine(i)) - vhat_ss(1);
end
vdif = vdif_ss; % if positive then inaction is optimal
ilow = find(vdif>0,1);
ilow      = max(1,ilow);
low_p_ss  = p_g_fine(ilow);
ihigh= find(vdif>0, 1, 'last' );
ihigh     = min(length(p_g_fine),ihigh);
high_p_ss =  p_g_fine(ihigh);

