function [fval] = fct_INT_Va(s,tau,PP,vhat_s,p)

global sigma mu p_g eta gamma

% the density of s is the standard normal (0,1)

x =  p + (gamma-mu)*tau + s.*sigma*sqrt(tau);

fval=zeros(1,length(x));
for ii=1:length(x)
    % The next lines are needed to avoid nasty behavior of splines outside domain of p_g
    if   ((p_g(1)) <= x(ii)) && ( x(ii) <= (p_g(end)) )
        fval(ii) =  fct_va(PP,vhat_s,x(ii))    .* normpdf(s(ii),0,1) ;
    elseif  x(ii) > (p_g(end))
        fval(ii) =  fct_va(PP,vhat_s,p_g(end)) .* normpdf(s(ii),0,1) ;
    else
        fval(ii) =  fct_va(PP,vhat_s,p_g(1))   .* normpdf(s(ii),0,1) ;
    end
    
end