%  Defines the parameters for the non-linear problem with n=1
%  parametrrs match observables produced  bu quadratic model
%  find parameters from the multi-p simulation that gives Na=1 Std = 0.10
Na     =    1     ;
std_Dp = 0.10    ;

%  use fundamental law of price gaps!
sigma =  std_Dp * sqrt(Na) ; 

%  given the B used in the quadratic,   find the eta consistent with it
B=20;
eta = (1+sqrt(1+8*B))/2;

psi   =    B*sigma^ 2 / (6*Na^2 ) ;    % use dixit's formula

rho   = 0.02;   % time discount, in years

mu    =  0.0 ; % drift of price gaps due to inflation.

%   PRODUCTIVITY growth parameter
gamma =  0.02 ; 

% The gamma below ensures consistency with the QJE  approximation  i.e. a case w/o drift
%  see the appendix in the aggregate shocks paper
% gamma =  mu + (2*eta-1)*sigma^2/2; %  
% mu + (2*eta-1)*sigma^2/2; %  


delta =  0.0  ; % substitutions (mortality rate)

B = eta*(eta-1)/2;

theta = 0    ;
psi   = 0.035 ;

%  Parameters of the household
alpha   = 0.5;
epsilon = 1;
R       = rho+mu;

% %parameters determining the grid of evaluation, the lenght of the impulse
% %response
% N_sim      = 1e6/2; %number of firms simulated to obtain the invariant distribution
% % T_end_ss   = 5  ;    %number of years simulated for each firm to obtain the invariant distribution
% dt  =  1/52; % 1/365/2   ; % half a day, as in th eother model  %0.01;
% dM         = 0.01;            %percentage increase in money supply
% time_shock = 1/10  ;          %time of the shock in the simulation of the IRF
% T_end_irf  = time_shock+ 2;   %length of the response to the aggregate shock in years
% 

disp('  ');
disp(' ***************  ');
disp('  ');
disp('Recall structural parameters:');
disp(['rho = ',num2str(rho,3),'; mu = ',num2str(mu,3),'; delta = ',num2str(delta,3),';   sigma =  ',num2str(sigma,3),'   theta = ',num2str(theta,2),';  psi = ',num2str(psi,2)]);

disp(['eta = ',num2str(eta,3),'; B = ',num2str(B,3),'; epsilon = ',num2str(epsilon,3),'; alpha  = ',num2str(alpha,3), ' ;   shock dM ',num2str(dM,3)]);
