function   [Pt]=fct_Pt_anal(t,delta,pbar,sigma,k_num)
%  difference between densities of hitting time for lower minus upper barrier
%  this formula assmes that delta <= pbar

if delta > pbar
   disp('formula does not apply')
end

ATOL=1e-12;

Theta = pbar/2*(delta/pbar)^2*(1+delta/pbar/3) ;

Pt= Theta ;

for k = 1 : k_num
    
    W = (k*pi)^2 * 1/2 * (sigma/pbar)^2*t;


    INT =   quadgk( @(p) (pbar+delta+p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-pbar, -delta ,'AbsTol',ATOL,'RelTol',0)...
         +  quadgk( @(p) (pbar-delta-p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-delta, pbar-delta,'AbsTol',ATOL,'RelTol',0 ) ; 

    
%     INT =   quad( @(p) (pbar+delta+p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-pbar, -delta , tol)...
%          +  quad( @(p) (pbar-delta-p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-delta, pbar-delta ,tol ) ; 

    Dp = (1-exp(-W))/(k*pi) * pbar * INT  ;
        
    Pt =  Pt + Dp  ; 
    
end

