function [ v_yz] = fun_eval_v(y,z,fitv_beta,psi,maxv) 
%%%
%%% inputs are vector of y,z, psi, maxv and coefficient of regression 
%%%

%%% uses this fit poynomimal value function 

%%% fitv = ols(v',XX') ; 
%%% fitv.beta is the OLS coefficient

%%% interpolate using fitted regression
v_0=fitv_beta(1)*ones(1,length(z));

if fun_eval_dvdy(y,z, fitv_beta) < -0.0
                v_yz = maxv; %%% if derivative is negative, assume it is control region
                
else
    XX=[ones(1,length(z)); y; y.^2; y.^3; z.^2; z.^4; y.*(z.^2); (y.^2).*(z.^2); (y.^3).*(z.^2)];
%    ; y.*(z.^4)];

    v_yz = fitv_beta'*XX;
    
end


v_yz = max(0, min(v_0 + psi , v_yz) );
