function y = fun_ybar_adjusted(z,fitv_beta,n,ybar_zzero) 
%%%
%%%  y = fun_ybar_adjusted(z,fitv_beta,n,ybar_zzero)
%%%
%%% inputs are vector of y,z,and coefficient of regression and n
%%%
%%% we find y s.t  dv(bary(z),z)/dy=0 and y(z) leq z^2/n. 
%%% 
%%% we adjsut the level of y so that the countour concides with the value
%%% found in the grid of the value function

%XX=[ones(1,length(z));y;y.^2;y.^3; z.^2;z.^4;y.*(z.^2); (y.^2).*(z.^2); (y.^3).*(z.^2)];

%v = fitv_beta'*XX;

beta=fitv_beta;

c = beta(2)+ beta(7).*z.^2;
b = 2*beta(3)+2*beta(8).*z.^2;
a = 3*(beta(4)+z.^2*beta(9));

y1 = (-b + sqrt(b.^2 - 4*a.*c))./(2*a);

y2 = (-b - sqrt(b.^2 - 4*a.*c))./(2*a);

for i=1:length(z);
    if min(y1(i),y2(i))< 0
        y(i) = max(y1(i) ,y2(i));
    else
        y(i) = min(y1(i) ,y2(i));
        
    end
end

y0 = fun_ybar(0,fitv_beta,n);

adj =  ybar_zzero - y0 ; 

y = max(y + adj , z.^2/n) ;
