% This file calls the function 
% fct_multipcorr(B,n,r,target_StdDp,target_Na,corr_dp,D,tolerance,Niter,Nsim)
% to solve and simulate seveal problems  with different n  and correlation
% of prices saving the output of the problem decision rules and
% simulations into separate files

clear all, close all; 

n_vec     = [ 50 50 ]     ;
corrp_vec = [ 0 1/2 ]     ;

delta_stdDp = 0.1;
Nfirms      = 500000;
D           = 1/365/2;

T  =  2   ; 
Ti =  2   ;

for i = 1:length(n_vec)
    
    n=n_vec(i);
    
    for j = 1:length(corrp_vec)
  
        corr_dp = corrp_vec(j);
        
        
        sim_name = ['simulp_n',num2str(n,2),'_corr_',num2str(corr_dp,3),'.mat'];  
        
        sim=load(sim_name);
        
        delta=delta_stdDp*sim.StdDp;
        
        clear sim;
                
        disp( '  ' );
        disp([ 'Computing IRF with  n= ',num2str(n),'  and corr(dp_i,dp_j) = ',num2str(corr_dp)  ]);

        outfilename = ['out_n',num2str(n,2),'_corr_',num2str(corr_dp,3),'.mat']; %out_nXX_corrYY.mat
        
        fct_IRF_corr_normal(outfilename,delta,Nfirms,T,Ti,D)

        % fct_multipcorr(B,n,r,target_StdDp,target_Na,corr_dp,D_val,D_sim,tolerance,Niter,Nsim);
    end
end


