% this file calls the function 
% fct_multipcross(eta,rho,n,r,target_StdDp,target_Na,corr_dp,D,tolerance,Niter,Nsim)
%  to solve and simulate several problems  with different n  and correlation
%  of prices and cross products saving the output of the problem decision rules and
%  simulations into separate files

clear all, close all; 

n_vec = [3] ;
corrp_vec = [0]  ;


% params  common to all problems
eta = 7;
rho = 14;
r = 0.05; 
 
target_StdDp = 0.10 ;
target_Na    = 1.5   ; 

D_val = 1/365/2;  % length of discrete time period  to solve value function
D_sim = 1/365/2 ;   % length of discrete time period  in simulation

tolerance = 1/50000;

Niter = 10000 ;
Nsim  = 25000 ;  %

for i = 1:length(n_vec)
    
    n=n_vec(i);
    
    for j = 1:length(corrp_vec)
        
        corr_dp = corrp_vec(j);
        
        disp( '  ' );
        disp([ 'Solving problem  with  n= ',num2str(n,2),'  and corr(dp_i,dp_j) = ',num2str(corr_dp)  ]);
        
        fct_multipcross(eta,rho,n,r,target_StdDp,target_Na,corr_dp,D_val,D_sim,tolerance,Niter,Nsim);
    end
end
