% close all
clear all; 

%xvec=[-1:0.001:1]; 
Na    = 1 %.24*12;
pbar  =  .1;

sigma = sqrt(Na) * pbar  ;  


% delta must be smaller than pbar
delta_vec = [0.02 ];

%delta_vec = [0.01:0.01:0.09  ];

%  important:  start at t=0 get the instantanoues jump THETA%
%tvec = [0:2/52: 1.5] ;
tvec = [0:1/365: 1.5] ;

%  max order of sums in  truncation of infinite sum
k_num = 15;

for j = 1:length(delta_vec)
    
    delta = delta_vec(j);
    
    for i=1:length(tvec)
        
        t = tvec(i);
        
%   compute the derivative of the irf
%         theta(i) = pbar * quad( @(p)   (pbar+delta+p)/pbar^2.*fct_g_anal(t,p,pbar,sigma,k_num),-pbar, -delta )...
%             + pbar * quad( @(p)   (pbar-delta-p)/pbar^2.*fct_g_anal(t,p,pbar,sigma,k_num),-delta, pbar-delta ) ;
%         
        %  compute the derivative of the irf  w.r.t.  delta
%        delta_theta(i) = -2/pbar* quad( @(p) fct_g_anal(t,p,pbar,sigma,k_num),0,pbar ) ;
        
        
     Pt(i,j)  = fct_Pt_anal(t,delta,pbar,sigma,k_num);
        
    end
    
end

% convert form weeks into months
t_month =  tvec*12;

% stop

figure(1)

ph=plot(t_month,100*Pt(:,1),'-',t_month,100*Pt(:,2),'--');
set(ph,'Linewidth',2) 
axis([0 max(t_month)  0 delta*100*1.05])
%title([' CPI  response after a ',num2str(delta*100,2),' percent monetary shock'],'Interpreter','Latex','Fontsize',16)
title([' CPI  response after a  monetary shock'],'Interpreter','Latex','Fontsize',16)
xlabel('months','Interpreter','Latex','Fontsize',14)
ylabel('CPI  response   (in \% )','Interpreter','Latex','Fontsize',14)
hline([delta_vec]*100)
lab1 = {['delta = ', num2str(delta_vec(1))]};
lab2 = {['delta = ', num2str(delta_vec(2))]};
legend([lab1, lab2],0 );
grid on;

figure(2)

ph=plot(t_month,100*(delta_vec(1)-Pt(:,1)),'-',t_month,100*(delta_vec(2)-Pt(:,2)),'--');
set(ph,'Linewidth',2) 
axis([0 max(t_month)  0 delta*100*1.05])
grid off;
%title([' Output response after a ',num2str(delta*100,2),' percent monetary shock'],'Interpreter','Latex','Fontsize',16)
title([' Output response after a  monetary shock'],'Interpreter','Latex','Fontsize',16)
xlabel('months','Interpreter','Latex','Fontsize',14)
ylabel(' $\delta - P(t)$  (in \% )','Interpreter','Latex','Fontsize',14)
hline([delta_vec]*100)
lab1 = {['delta = ', num2str(delta_vec(1))]};
lab2 = {['delta = ', num2str(delta_vec(2))]};
legend([lab1, lab2],0 );

