
clear all; close all;

B=20;
sigma=0.1;
psi=0.1;
r=0.001;
lambda=0.001;

n_terms=50;

n=40;

z_vec=[0:2:5000];

for j=1:length(z_vec)
    
    z=z_vec(j) ;
    
    omega(1) = 1/(3*(n+4));
    sum_z_1 = 2*(n+2)*z + z^2   ;
    sum_z_2 = 2*(n+2)*z + 2*z^2 ;
    rhs_quad_v(j) = z*( 1 - (sum_z_1/sum_z_2));
    sum_z_1 =  sum_z_1 + z^2*omega(1)*z;
    sum_z_2 =  sum_z_2 + z^2*omega(1)*3*z;
    rhs_cubic_v(j) = z*( 1 - (sum_z_1/sum_z_2));
    for i=2:n_terms
        omega(i)= omega(i-1)/((i+2)*(n+2*i+2));
        sum_z_1 = z^2*omega(i)*z^i + sum_z_1 ;
        sum_z_2 = z^2*omega(i)*(i+2)*z^i + sum_z_2 ;
    end
    
    rhs_exact(j) = z*( 1 - sum_z_1/sum_z_2) ;
    
    rhs_quad_theta(j) =  z^2 /(2*(n+2)); 
    
    
    
end

figure(1);
plot(z_vec,rhs_quad_theta./rhs_exact,'-',z_vec,rhs_quad_v./rhs_exact,'--','LineWidth',3);
title('Ratio of functions for exact to approximate solutions','Interpreter','Latex','FontSize',18)
le=legend('quad $\Theta$/exact', 'quad $v$/ exact'); set(le,'Interpreter','Latex','FontSize',18);
xlabel('$z = y (r+\lambda)/\sigma^2$','Interpreter','Latex','FontSize',18)
axis([0 max(z_vec) 0.5 1])


figure(2);
plot(z_vec,rhs_exact,'-',z_vec,rhs_quad_v,'.-',z_vec,rhs_cubic_v,'--',...
z_vec,rhs_quad_theta,'.',z_vec,ones(1,length(rhs_exact))*psi*n*(r+lambda)^2/(B*sigma^2),'LineWidth',2);
title('Function $\Theta$','Interpreter','Latex','FontSize',18);
le = legend('Exact','quad $v$','cubic $v$','quad $\Theta$'); set(le,'Interpreter','Latex','FontSize',18);
xlabel('$z = y (r+\lambda)/\sigma^2$','Interpreter','Latex','FontSize',18);
ylabel('$\Psi (r +\lambda)^2 / (B \sigma^2) $','Interpreter','Latex','FontSize',18)
%axis([0 0.1 0 0.001])
zsol = sqrt( psi*n*2*(n+2)/(B*sigma^2))*(r+lambda);
vline(zsol,'g','z');

