function   [Y_I]=fct_YI_anal(delta,pbar,sigma,k_num)
% Y_I is the integral between t=0 and infty of the output deviations after a shock of size delta
% N_a is normalized to one, this is for the case of n=1
%  this formula assmes that delta <= pbar

if delta > pbar
   disp('formula does not apply')
end

ATOL=1e-12;

Y_I= 0;

Na = sigma^2/pbar^2;

for k = 1 : k_num
    
%   old formula  for integration
%     INT =   quad( @(p) (pbar+delta+p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-pbar, -delta )...
%          +  quad( @(p) (pbar-delta-p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-delta, pbar-delta ) ; 

     INT =   quadgk( @(p) (pbar+delta+p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-pbar, -delta,'AbsTol',ATOL,'RelTol',0)...
          +  quadgk( @(p) (pbar-delta-p)/pbar^2.*( sin(k*pi*(1+p/pbar))-sin(k*pi*(1-p/pbar))),-delta, pbar-delta,'AbsTol',ATOL,'RelTol',0 ) ; 
        
    DY = 2 /(k*pi)^3 * (pbar/Na) * INT  ;
    
    Y_I =  Y_I + DY  ;
    
end

