function  [lambda_Na]  =  fct_lambda_Na(x,n,N_prod)
%  Computes the value of lambda/Na given n  and  x=ybar*lambda/sigma^2
%  Nprod is the number of terms used

prod(1) = 1/(2*(n+2));
T_zero = 1;
for i=1:N_prod
    T_zero = T_zero + x^i*prod(i);
    k = i+1;
    prod(i+1) = prod(i)/((k+1)*(n+2*k));
end
lambda_Na = ( x/n*T_zero / (1+ x/n*T_zero));

