function mom = fun_price_dist_multi_moment(p,barR,n,k)
% function to be integrated to obtain moment k of the distribtion of price changes given barR
% model with n products
% mom = h(p;n,barR) p^k , where h(p;n,barR) is the density of the price
% change given n products and barR. 


    const = gamma(n/2)./gamma(1/2)./gamma((n-1)/2)./sqrt(barR);
    
    
    if abs(p/sqrt(barR) ) <= 1
            mom = const .* p.^k .* ( ( 1 - (p./sqrt(barR)).^2 ).^((n-3)/2) );
    end
    if abs(p/sqrt(barR) ) > 1
            mom = 0 ;
    end