% this file computes the maximum kurtosis
% consistent with a value of Na for a given n. 

clear all; close all;

% parameters

sigma=0.15/1.5;
tol=1e-10;  %  precision of quadrature

n_vec  =[2    5    6    10   20] ;
Na_vec =[2.4  2.3  2.8  3.5 3.5]; 



for i=1:length(n_vec);
    
    lambda = Na_vec(i) ;
    
    n=n_vec(i);
    
    nu= abs(n/2-1);
   
    
    y_max=20;

    nsteps=500;
    
    y_vec =[y_max/nsteps:y_max/nsteps:y_max];
    dy = y_vec(2)-y_vec(1);
    
%     for j=1:length(y_vec)
%         y= y_vec(j);
%         f(j,i) =  y^(n/4-1/2)*besselk(nu,2*sqrt(y*lambda/(2*sigma^2))) ;
%     end
%     
%     C = 1/(sum(f(:,i))*dy);
   
    C = 1/quad(@(y) y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))),0,y_max,tol);
    
    
    y = y_max;
    if y * y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))) > 0.01
       y_max=y_max*2;
    elseif y * y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))) < 0.000000000001
       y_max=y_max/2;
    end
    
    C = 1/quad(@(y) y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))),0,y_max,tol);
    
    %f(:,i) = C * f(:,i);
    
    %mom4 = y_vec.^2 *f(:,i) * dy;
    %mom2 = y_vec *f(:,i) * dy;
    
   
    mom4 = quad(@(y) y.^2*C.*y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))),0,y_max,tol);
    mom2 = quad(@(y)   y.*C.*y.^(n/4-1/2).*besselk(nu,2.*sqrt(y*lambda/(2*sigma^2))),0,y_max,tol);
    
    
    CC(i) = C;
    yy_max(i) = y_max;
    
    kurt(i) = 3*n/(2+n) * mom4/mom2^2;
    
    
end
    

disp('  ');
disp(' ****** ');

disp(['code computes  kurtosis for large lambda i.e.  lambda == Na  (i.e. ybar == infty)'  ]);

disp('  ');
disp(['number of goods  n '  ]);
disp(num2str(n_vec, 3));
disp('  ');
disp(['number of adjustment per period Na'  ]);
disp(num2str(Na_vec, 3));
  
disp('  ');
disp('  ');
disp('kurtosis  (E Dp^4  /   (E Dp^2)^2    as n varies  ');
disp(num2str(kurt, 3));

    
    
      