%  multi product  PDE - Alvarez Lippi
clear all; close all;

r     = 0.02;
B     =   20;
n     =   5;  % number of goods
sigma = 0.20;
psi   = 0.05;
 
% solve f(0)+psi=f(Rbar)  and fprime(Rbar)=0

Rbar_guess = (psi*sigma^2*2 *(n+2)/B )^0.5 ;
beta0_guess = n*sigma^2/r * 2*psi/Rbar_guess;  %  guess value function at R=zero

x0 = [beta0_guess,Rbar_guess];

options = optimset('TolFun',[1e-12],'TolX',[1e-12],'MaxFunEvals',[1000]);

[Xsol,fval, eflag] = fsolve( @(x) fun_system(x,psi,r,B,sigma,n), x0, options );


beta0 = Xsol(1);
Rbar  = Xsol(2);
pbar  = sqrt(Rbar);


pbarMC = (6*psi*sigma^2/B)^(1/4);


disp([' multiproduct pbar  ',num2str(pbar, 5)]);
disp([' monoproduct  pbar  ', num2str(pbarMC, 5)]);
disp([' beta0  ',num2str(beta0, 5)]);


beta_vec(1) =  beta0*r/(n*sigma^2);
beta_vec(2) = ( r*beta_vec(1) - B )/( 2*sigma^2*(n+2) );
i_length = 10;
% now do beta 3,4, etc
for i=2:i_length
    beta_vec(i+1) = beta_vec(i)*r/(  sigma^2* (n+2*i)*(i+1));
end

R_vec=[0.001 :  Rbar/100: 1.5*Rbar];
plot(R_vec, fun_f(R_vec, beta0, beta_vec));

pbarMC= (6*psi*sigma^2/B)^(1/4);

vline(Rbar); hline(fun_f(Rbar,beta0, beta_vec));
vline(pbarMC^2,'g','menu cost n=1');
