%  multi product  PDE - Alvarez Lippi
clear all; close all;

r      = 0.03;
B      =   20;
nn     =  100;  % maximum number of goods
%nn     =  1000;  % maximum number of goods
sigma  = 0.20;
psi_1  = 0.03;
%psi_1  = 1;
 
i_length = 30; % number of beta terms to keep

% solve f(0)+psi=f(Rbar)  and fprime(Rbar)=0

for n=1:nn
    
    % first solve CRTS menu cost psi = psi_1 * n
    
    psi=psi_1*n ; % uses constant returns to scale assumption
    
    Rbar_guess_rzero = (psi*sigma^2*2 *(n+2)/B )^0.5 ;
    
    % Rbar guess with discounting:
    s=sigma^2*(n+2);
    Rbar_guess = 2*psi/(-r*psi/s + sqrt( (r*psi/s)^2 + 2*B*psi/s  ) );
    
    %%% Rbar_guess = (psi*n*sigma^2*6/B )^0.5 ;
    
    beta0_guess = n*sigma^2/r * 2*psi/Rbar_guess;  %  guess value function at R=zero
    
    x0 = [beta0_guess,Rbar_guess];
    
    %options = optimset('TolFun',[1e-16],'TolX',[1e-16],'MaxFunEvals',[1000]);
    
    options = optimset('TolFun',[1e-16],'TolX',[1e-16],'MaxFunEvals',[1000], 'Display','off');
    
    
    [Xsol,fval, eflag] = fsolve( @(x) fun_system(x,psi,r,B,sigma,n), x0, options );
    
    
    beta0 = Xsol(1);
    Rbar  = Xsol(2);
    pbar  = sqrt(Rbar);
    
    
    beta_vec(1) =  beta0*r/(n*sigma^2);
    beta_vec(2) = ( r*beta_vec(1) - B )/( 2*sigma^2*(n+2) );
    
    
    % now do beta 3,4, etc
    for i=2:i_length
        beta_vec(i+1) = beta_vec(i)*r/(  sigma^2* (n+2*i)*(i+1));
    end
    
    
    Rbar_sol_CRTS_vec(n) = Rbar;
    Rbar_guess_CRTS_vec(n) = Rbar_guess;
    Rbar_guess_rzero_CRTS_vec(n) = Rbar_guess_rzero;
    beta_zero_guess_CRTS_vec(n) = beta0_guess;
    beta_CRTS_mat(n,:)   = beta_vec;
    beta_zero_sol_CRTS_vec(n) = beta0;
    
    
    % now solve constant psi
    
    psi = psi_1 ;
    
    
    Rbar_guess_rzero = (psi*sigma^2*2 *(n+2)/B )^0.5 ;
    
    % Rbar guess with discounting:
    s=sigma^2*(n+2);
    Rbar_guess = 2*psi/(-r*psi/s + sqrt( (r*psi/s)^2 + 2*B*psi/s  ) );
    
    %%%Rbar_guess = (psi*n*sigma^2*6/B )^0.5 ;
    
    beta0_guess = n*sigma^2/r * 2*psi/Rbar_guess;  %  guess value function at R=zero
    
    x0 = [beta0_guess,Rbar_guess];
    
    options = optimset('TolFun',[1e-16],'TolX',[1e-16],'MaxFunEvals',[1000]);
    
    [Xsol,fval, eflag] = fsolve( @(x) fun_system(x,psi,r,B,sigma,n), x0, options );
    
    
    beta0 = Xsol(1);
    Rbar  = Xsol(2);
    pbar  = sqrt(Rbar);
    
    
    beta_vec(1) =  beta0*r/(n*sigma^2);
    beta_vec(2) = ( r*beta_vec(1) - B )/( 2*sigma^2*(n+2) );
    
    % now do beta 3,4, etc
    for i=2:i_length
        beta_vec(i+1) = beta_vec(i)*r/(  sigma^2* (n+2*i)*(i+1));
    end
    
    
    Rbar_sol_vec(n) = Rbar;
    Rbar_guess_vec(n) = Rbar_guess;
    Rbar_guess_rzero_vec(n) = Rbar_guess_rzero;
    beta_zero_guess_vec(n) = beta0_guess;
    beta_mat(n,:)   = beta_vec;
    beta_zero_sol_vec(n) = beta0;
     
    
    
end

%vline(Rbar); hline(fun_f(Rbar,beta0, beta_vec));
%vline(pbarMC^2,'g','menu cost n=1');

figure(1);
ph= plot([1:1:nn],Rbar_guess_rzero_vec./Rbar_sol_vec,[1:1:nn],Rbar_guess_rzero_CRTS_vec./Rbar_sol_CRTS_vec);
%th=title('Ratio between exact and approximate \bar R for constant menu cost and linear menu cost') ;

%maxy = max(max(Rbar_guess_vec./Rbar_sol_vec), max(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%miny = min(min(Rbar_guess_vec./Rbar_sol_vec), min(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%axis([1 nn min(0.999*miny,1) min(1.001*maxy,1)]);
grid on ;
xh = xlabel('number of products $n$','Interpreter','LaTex');
yh = ylabel('$\bar y$ approx. / $\bar y$ exact','Interpreter','LaTex');
legend('\psi  constant','\psi  linear in n', 'Location','East') ;
set(ph,'LineWidth',3);
set(gca,'FontSize',15);
% set(th,'FontSize',18);
set(xh,'FontSize',18);
set(yh,'FontSize',18);
orient landscape
%print -depsc .\fig2_ratioRbars



figure(2);
ph= plot([1:1:nn],beta_zero_guess_vec./beta_zero_sol_vec,[1:1:nn],beta_zero_guess_CRTS_vec./beta_zero_sol_CRTS_vec);
%th=title('Ratio between exact and approximate v(0) for constant menu cost and linear menu cost') ;

%maxy = max(max(Rbar_guess_vec./Rbar_sol_vec), max(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%miny = min(min(Rbar_guess_vec./Rbar_sol_vec), min(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%axis([1 nn min(0.999*miny,1) min(1.001*maxy,1)]);
grid on ;
xh = xlabel('number of products n','Interpreter','LaTex');
yh = ylabel('ratio of $v(0)$ approx to $v(0)$ exact','Interpreter','LaTex');
legend('\psi  constant','\psi  linear in n', 'Location','East') ;
set(ph,'LineWidth',3);
set(gca,'FontSize',15);
% set(th,'FontSize',18);
set(xh,'FontSize',18);
set(yh,'FontSize',18);
orient landscape
%print -depsc .\fig2_ratiobeta_0

nn_max=50;
figure(3);
ph= plot([1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_sol_CRTS_vec(1:nn_max),'ko',...
    [1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_guess_rzero_CRTS_vec(1:nn_max),'g-',...
    [1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_sol_vec(1:nn_max),'rx',[1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_guess_rzero_vec(1:nn_max),'c:');
%th=title('Frequency of adjustment, CRTS case') ;

%maxy = max(max(Rbar_guess_vec./Rbar_sol_vec), max(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%miny = min(min(Rbar_guess_vec./Rbar_sol_vec), min(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%axis([1 nn min(0.999*miny,1) min(1.001*maxy,1)]);
grid on ;
xh = xlabel('number of products $n$','Interpreter','LaTex');
yh = ylabel('Frequency of adjustment $n_a$, exact and approx case','Interpreter','LaTex');
legend('exact CRTS','approx. CRTS', 'exact','approx.', 'Location','East') ;
set(ph,'LineWidth',3);
set(gca,'FontSize',15);
% set(th,'FontSize',18);
set(xh,'FontSize',18);
set(yh,'FontSize',18);
orient landscape
%print -depsc .\fig3_na


nn_max=50;
figure(4);
ph= plot([1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_sol_CRTS_vec(1:nn_max),'ko',...
    [1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_guess_rzero_CRTS_vec(1:nn_max),'g-');
%th=title('Frequency of adjustment, CRTS case') ;
%th=title('Frequency of adjustment, CRTS case') ;

%maxy = max(max(Rbar_guess_vec./Rbar_sol_vec), max(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%miny = min(min(Rbar_guess_vec./Rbar_sol_vec), min(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%axis([1 nn min(0.999*miny,1) min(1.001*maxy,1)]);
grid on ;
xh = xlabel('number of products $n$','Interpreter','LaTex');
yh = ylabel('Freq. of adjustment $N_a$, exacct and approx. case','Interpreter','LaTex');
legend('exact CRTS','approx. CRTS', 'Location','East') ;
set(ph,'LineWidth',3);
set(gca,'FontSize',15);
% set(th,'FontSize',18);
set(xh,'FontSize',18);
set(yh,'FontSize',18);
orient landscape
%print -depsc .\fig3_na_CRTS

nn_max=50;
figure(5);
ph= plot([1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_sol_vec(1:nn_max),'ko',...
    [1:1:nn_max],sigma^2*[1:1:nn_max]./Rbar_guess_rzero_vec(1:nn_max),'g-');
%th=title('Frequency of adjustment, constant menu cost case') ;

%maxy = max(max(Rbar_guess_vec./Rbar_sol_vec), max(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%miny = min(min(Rbar_guess_vec./Rbar_sol_vec), min(Rbar_guess_CRTS_vec./Rbar_sol_CRTS_vec));
%axis([1 nn min(0.999*miny,1) min(1.001*maxy,1)]);
grid on ;
xh = xlabel('number of products $n$','Interpreter','LaTex');
yh = ylabel('Freq. of adjustment $N_a$, exact and approx. case','Interpreter','LaTex');
legend('exact CRTS','approx. CRTS', 'Location','East') ;
set(ph,'LineWidth',3);
set(gca,'FontSize',15);
% set(th,'FontSize',18);
set(xh,'FontSize',18);
set(yh,'FontSize',18);
orient landscape
%print -depsc .\fig3_na_const

% Value functions for n=2


ybar = Rbar_sol_vec(2);
y_vec = [0:ybar/100:ybar*1.2];


for i=1:length(y_vec)
    y = y_vec(i);
    if y > ybar
        v = beta_zero_sol_vec(2) + psi_1;
    else
        v = beta_zero_sol_vec(2);
        for j=1:length(beta_mat(2,:))
            v = beta_mat(2,j)*(y^j) + v ;
        end
    end
    v_f2(i) = v;
end
    


figure(6) ; 
ph= plot(y_vec,v_f2);
set(ph,'LineWidth',3);
vline(ybar,'g','');
text(ybar,beta_zero_sol_vec(2),'$\bar y$','Interpreter','Latex','FontSize',18)
xlabel('$y = ||p||^2$','Interpreter','Latex','FontSize',18);
ylabel('value function $v(y)$','Interpreter','Latex','FontSize',18);

orient landscape
print -depsc .\fig_value_function_v2_y

clear p1 p2 V_f2
[p1,p2]=meshgrid(-sqrt(ybar)*1.2:sqrt(ybar)/30:sqrt(ybar)*1.2,-sqrt(ybar)*1.2:sqrt(ybar)/30:sqrt(ybar)*1.2);

for i1=1:length(p1)
    for i2=1:length(p2)
        y = p1(i1,i2)^2 + p2(i1,i2)^2;
        if y > ybar
            v = beta_zero_sol_vec(2) + psi_1;
        else
            v = beta_zero_sol_vec(2);
            for j=1:length(beta_mat(2,:))
                v = beta_mat(2,j)*(y^j) + v ;
            end
        end
        V_f2(i1,i2) = v;
    end
end

figure(7) ; surf(p1,p2,V_f2);
xlabel('$p_1$','Interpreter','Latex','FontSize',18);
ylabel('$p_2$','Interpreter','Latex','FontSize',18);
zlabel('value function $V(p_1,p_2)$','Interpreter','Latex','FontSize',18);



orient landscape
%print -depsc .\fig_value_function_V2_p





