%  Computes the fraction of price changes after aggregate shock
clear all;  close all;

%  Compute objects of proposition 10-11
tic 

psi_1 = 0.03   ;
B     = 15     ;
sigma = 0.10   ;

delta     = 1e-4; % 0.0125 ; 
delta_big = 0.1;

%  nb.  n = 1 is not admitted because the density S has a mass point for n=2  you need to change  Fy
%  n_vec = [1 2 4 8 10 50 100];

n_vec = [1:1:50];

% Loop    for  small delta  
for i = 1 : length(n_vec)
    %  compute y-low
   
    n =  n_vec(i);
 
    psi = psi_1;
      
    ybar= sqrt(2*(n+2)*psi*sigma^2/B);
    ybar_vec(i)=ybar;
    
   % delta_vec(i)=2*sqrt(ybar/n);
   % delta = delta_vec(i);
 
    ylow = ( max(1e-16,sqrt(ybar)-delta*sqrt(n)) )^2 ;
    ylow_vec(i)=ylow; 
    %  the next one works except for n=1
    % PHI(i)  = fct_SS(fct_nu(ybar,delta,ybar,n),n)  -  quad(  @(z) fct_Fy(z,n,ybar).*fct_s( fct_nu(z,delta,ybar,n),n) .* fct_nu_y(z,delta,n,ybar) , ylow,ybar   ) ;
    
    %  this uses equation 27
    
 
    if n ==1
        
        if delta<=sqrt(ybar)   
        PHI(i) = 1/(2*ybar ) * delta^2;  % 
        THETA(i)=   quadgk( @(y) 0.5*fct_f(y,n,ybar).*(sqrt(y)+delta), (sqrt(ybar)-delta)^2, ybar ) ; 
  
        
        else 
            
        PHI(i) = min ( 1,  1 - 1/2*(2*sqrt(ybar)-delta)^2/ybar) ;  % 

        THETA(i)= delta*PHI(i) ...
                     +  quadgk( @(p)   (-p).*(sqrt(ybar)+p)/ybar, -sqrt(ybar),0) ...
                     +  quadgk( @(p)   (-p).*(sqrt(ybar)-p)/ybar, 0,delta-sqrt(ybar) ); 
        
        THETA(i) = min(delta, THETA(i)) ; 

        end 
        
        PHI_const(i)=PHI(i);
        THETA_const(i)=THETA(i);
        
        
        FF(i) =1;
        QQ(i) =1;
            
        
%         PHI(i) = 1/(2*ybar ) * delta^2;  % 
%         THETA(i)=   quadgk( @(y) 0.5*fct_f(y,n,ybar).*(sqrt(y)+delta), (sqrt(ybar)-delta)^2, ybar ) ; 
%         E_Dp(i) = sqrt(ybar) ; 
%         
%         FF(i) =1;
%         QQ(i) =1;
%         
    else
        tol=1e-12;
        PHI(i)  =  quadgk(  @(y) fct_f(y,n,ybar).*fct_SS(fct_nu(y,delta,ybar,n),n), ylow,ybar) ;
        THETA(i) =  delta*PHI(i) + quadgk(  @(y) fct_f(y,n,ybar).*sqrt(y/n) ...
            .* ( 1- min( 1 , fct_nu(y,delta,ybar,n).^2 /n) ).^( (n-1)/2 ) / ( (n-1)*beta((n-1)/2,1/2) ), ylow, ybar) ;
    
        ybar_temp=ybar;  
        ylow_temp=ylow;  
        delta_temp=delta;
        ybar=1;
        ylow=ylow_temp/ybar_temp; 
        delta=delta_temp/sqrt(ybar_temp);
        
        theta(i) =  delta*PHI(i) + quadgk(  @(y) fct_f(y,n,ybar).*sqrt(y/n) ...
            .* ( 1- min( 1 , fct_nu(y,delta,ybar,n).^2 /n) ).^( (n-1)/2 ) / ( (n-1)*beta((n-1)/2,1/2) ), ylow, ybar) ;
        phi(i)  =  quadgk(  @(y) fct_f(y,n,ybar).*fct_SS(fct_nu(y,delta,ybar,n),n), ylow,ybar ) ;
        delta = delta_temp;
        ybar=ybar_temp;
        ylow=ylow_temp; 
        
        FF(i) = PHI(i)/PHI(1);
        QQ(i) = THETA(i)/THETA(1);
        
        
    end
    
end

FF_const = FF; 
QQ_const = QQ; 

FF_crs = FF./n_vec.^(1/2); 
QQ_crs = QQ./n_vec.^(1/4); 

psi_cN =  n_vec.^2 * 3 ./(n_vec+2);

FF_cN = FF./ (psi_cN.^(1/2));
QQ_cN = QQ./ (psi_cN.^(1/4));

figure(1)
plot(n_vec,FF_const,'--', n_vec,FF_cN,'-','LineWidth', 3);
lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
% ti=title({'Fraction of firms that change prices right after a monetary shock',
%     'as a ratio to the case of $n=1$'});
% set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Number of Products, $n$');
set(xl, 'fontsize',16,'Interpreter','Latex');

% print -depsc  ./figures/fig_impulse_monetary_fraction


figure(2)
plot(n_vec,QQ_const,'--',n_vec,QQ_cN,'-','LineWidth', 3);
lh=legend('$\mathcal{Q}_n$  ','$\Theta_n/\Theta_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
% ti=title({'Average Price change right after a monetary shock',
%     'as a ratio to the case of $n=1$'});
% set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Number of Products, $n$');
set(xl, 'fontsize',16,'Interpreter','Latex');

% print -depsc  ./figures/fig_impulse_monetary_agg_price

 
figure(3)
plot(n_vec,QQ_cN,'-','LineWidth', 3);
lh=legend('$\Theta_n/\Theta_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
% ti=title({'Average Price change right after a monetary shock',
%     'as a ratio to the case of $n=1$'});
% set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Number of Products, $n$');
set(xl, 'fontsize',16,'Interpreter','Latex');
 
 
% n=2;
% z_vec=[-sqrt(n)+1e-6:0.01:sqrt(n)-1e-6];
% N_order_approx =10;
% 
% for jj=1:length(z_vec)
%     
%     z=z_vec(jj);
%     SS_quad(jj)=fct_SS(z,n);
%     SS_hypg(jj)=(z)*hypergeometric2f1(1/2,(3-n)/2,3/2,z^2/n,N_order_approx)+(sqrt(n))*hypergeometric2f1(1/2,(3-n)/2,3/2,1,N_order_approx);
%     SS_hypg(jj)=    SS_hypg(jj)/(sqrt(n)*beta((n-1)/2,1/2));
% end
% plot(z_vec,SS_quad, 'r', z_vec,SS_hypg,'b');
% hline(1/2);vline(0);

disp( ' ****** ') ;



%delta
n_vec

% disp('PHI  from computing eq  37  ' )
% PHI
 disp('fraction firms responding :  PHI  ' )
 PHI 

disp('% change of aggregate price  :  THETA  ' )
THETA 


disp('fraction firms responding, normalized by  shock :  PHI / delta^2 ' )
PHI/delta^2

 disp('% change of aggregate price , normalized by  shock :  THETA / delta^2' )
 THETA./delta^2

 disp('fraction firms responding, relative to GL ' )
 FF

 disp('% change of aggregate price , relative to GL' )
 QQ
 
 
% 
disp('Mean  Dp   for firms that adjust :  THETA / PHI' );
% 
 THETA./PHI
 

% % clear all
% nindx=3;
% n=n_vec(nindx); ybar=ybar_vec(nindx);
% delta=1e-4;
% ylow= ( max(1e-20,sqrt(ybar)-delta*sqrt(n)) )^2 ;
% y_vec=[ylow+(ybar-ylow)*1/400:(ybar-ylow)/300:ybar];
% 
% PHI_check = quad(@(yy)  fct_f(yy,n,ybar).*fct_SS(fct_nu(yy,delta,ybar,n),n),ylow,ybar );
% 
% 
% for jj=1:length(y_vec)
%     
%     y=y_vec(jj);
%     
%     check1_int(jj) =  sqrt(n)*( 1- min( 1 , fct_nu(y,delta,ybar,n).^2 /n) ).^( (n-1)/2 ) / ( (n-1)*beta((n-1)/2,1/2) ) ;
%     check2_int(jj) =  - quad(@(z) z.*fct_s(z,n),-sqrt(n),fct_nu(y,delta,ybar,n) ) ;
%     
%     %  mean price change  conditional on y, n
%     E_Dp_y(jj) = sqrt(y)/n* check1_int(jj)/ fct_SS(fct_nu(y,delta,ybar,n),n)  ;
%     check2_int_S(jj) = sqrt(y)/n* check2_int(jj)/ fct_SS(fct_nu(y,delta,ybar,n),n) ;
%     
%     %  density of y conditional on adjusting   
%     conditional_f(jj)  =  fct_f(y,n,ybar)*fct_SS(fct_nu(y,delta,ybar,n),n)/PHI_check  ;
%         
% end
% 
% % check_integrate  = sum( conditional_f ) * (y_vec(2)-y_vec(1))   ;
% 
% E_Dp_mean  = sum( conditional_f.*E_Dp_y) * (y_vec(2)-y_vec(1))  ; 
% 
% figure(20)
% plotyy(y_vec,E_Dp_y , y_vec,conditional_f )
% legend('conditional Dp', 'conditional density');
% hline(E_Dp_mean,'r','conditional mean  of Dp');
%  
%  E_Dp_mean
toc
