%  Computes the fraction of price changes after aggregate shock
clear all;  close all;


psi_1 = 0.025   ;
B     = 15     ;
sigma = 0.1   ;


delta     = 1e-4; % 0.0125 ; 
delta_big = 0.1;

n=1;
ybar  = sqrt(2*(n+2)*psi_1*sigma^2/B);

Na     = sigma^2/ybar ;   
Std_Dp = sqrt(ybar)  ;

%  nb.  n = 1 is not admitted because the density S has a mass point for n=2  you need to change  Fy
%  n_vec = [1 2 4 8 10 50 100];

n_vec=[1 2 10 30];

psi=psi_1;

ybar1 = sqrt(2*(1+2)*psi*sigma^2/B);
deltamax =  2*sqrt(ybar1); 

delta_vec = linspace(1e-6,deltamax,200);


for in=1:length(n_vec)
 
 n=n_vec(in);   

 ybar_vec(in)= sqrt(2*(n+2)*psi*sigma^2/B);

 % The next one keeps Na   constant
 psi_n=psi_1*3/(n+2)*n^2;
 ybar_const_vec(in)= sqrt(2*(n+2)*psi_n*sigma^2/B);
 
 for id = 1 :length(delta_vec)
  ybar = ybar_vec(in); 
  ybar_const=ybar_const_vec(in);
  delta =  delta_vec(id);
  
  ylow = ( max(1e-16,sqrt(ybar)-delta*sqrt(n)) )^2 ;
  ylow_const = ( max(1e-16,sqrt(ybar_const)-delta*sqrt(n)) )^2 ;

  
    if n ==1
        
        
        if delta<=sqrt(ybar)   
        PHI(in,id) = 1/(2*ybar ) * delta^2;  % 
        THETA(in,id)=   quadgk( @(y) 0.5*fct_f(y,n,ybar).*(sqrt(y)+delta), (sqrt(ybar)-delta)^2, ybar ) ; 
        THETA_norm(in,id) = THETA(in,id)/delta;

        
        else 
            
        PHI(in,id) = min ( 1,  1 - 1/2*(2*sqrt(ybar)-delta)^2/ybar) ;  % 

        THETA(in,id)= delta*PHI(in,id) ...
                     +  quadgk( @(p)   (-p).*(sqrt(ybar)+p)/ybar, -sqrt(ybar),0) ...
                     +  quadgk( @(p)   (-p).*(sqrt(ybar)-p)/ybar, 0,delta-sqrt(ybar) ); 
        
        THETA(in,id) = min(delta, THETA(in,id)) ; 

        THETA_norm(in,id)= THETA(in,id)/delta;
        
        end 
        
        PHI_const(in,id)=PHI(in,id);
        THETA_const(in,id)=THETA(in,id);
        
        
        FF(in,id) =1;
        QQ(in,id) =1;
        
        
    else  %  n>1 
      %   tol=1e-12;
        PHI(in,id)  =  quadgk(  @(y) fct_f(y,n,ybar).*fct_SS(fct_nu(y,delta,ybar,n),n), ylow,ybar) ;
        PHI(in,id) = min(1, PHI(in,id)) ;
        
        THETA(in,id) =  delta*PHI(in,id) + quadgk(  @(y) fct_f(y,n,ybar).*sqrt(y/n) ...
            .* ( 1- min( 1 , fct_nu(y,delta,ybar,n).^2 /n) ).^( (n-1)/2 ) / ( (n-1)*beta((n-1)/2,1/2) ), ylow, ybar) ;
        THETA(in,id) = min(delta, THETA(in,id)) ;
        
        THETA_norm(in,id)= THETA(in,id)/delta;
        
        FF(in,id) = PHI(in,id)/PHI(1);
        QQ(in,id) = THETA(in,id)/THETA(1);


          %  constant stuff
          ybar = ybar_const;
          ylow = ylow_const;
        PHI_const(in,id)  =  quadgk(  @(y) fct_f(y,n,ybar).*fct_SS(fct_nu(y,delta,ybar,n),n), ylow,ybar) ;
        PHI_const(in,id) = min(1, PHI_const(in,id)) ; 

        
        THETA_const(in,id) =  delta*PHI_const(in,id) + quadgk(  @(y) fct_f(y,n,ybar).*sqrt(y/n) ...
            .* ( 1- min( 1 , fct_nu(y,delta,ybar,n).^2 /n) ).^( (n-1)/2 ) / ( (n-1)*beta((n-1)/2,1/2) ), ylow, ybar) ;        
        THETA_const(in,id) = min(delta, THETA_const(in,id)) ;
      
        
        
        
        
        
    end%  if n=1
  

 end %  id

end% in  


 
figure(1)
plot(delta_vec,PHI,'--','LineWidth', 3);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=50 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
ti=title('Fraction of adjusters after a monetary shock'); 
 set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');
% print -depsc  ./figures/fig_BLABLABLA
 


figure(2)
plot(delta_vec,THETA_norm,'-','LineWidth', 2);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
ti=title('NORMALIZED Impact on  Price Level '); 
 set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');


figure(3)
plot(delta_vec,THETA_norm,'-','LineWidth', 2);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
ti=title('ZOOM  NORMALIZED Impact on  Price Level '); 
 set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');
axis([0 1e-2/2 0  .021] )


figure(4)
plot(delta_vec,THETA,'--',delta_vec,delta_vec,':k','LineWidth', 3);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
ti=title('Impact on  Price Level '); 
 set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');


figure(5)
plot(delta_vec,PHI_const,'-','LineWidth', 2);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
ti=title('Fraction of adjusters  keeping $N_a$ constant'); 
 set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');



figure(6)
plot(delta_vec/Std_Dp,THETA_const/Std_Dp,'-',delta_vec/Std_Dp,delta_vec/Std_Dp,':k','LineWidth', 1.5);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
%ti=title('Impact on  Price Level keeping $N_a$ constant'); 
% set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of normalized monetary shock  , $\frac{\delta}{Std[\Delta_p]}$');
set(xl, 'fontsize',16,'Interpreter','Latex');
yl=ylabel(' $\Theta_n\left(\frac{\delta}{Std(\Delta p}\right) \ / \ Std[\Delta p]$ ');
set(yl, 'fontsize',16,'Interpreter','Latex');

% axis([0 2*sqrt(ybar_const_vec(1)) 0  2*sqrt(ybar_const_vec(1))] )
% axis([0 .12 0  .12] )

% orient landscape
% print -depsc  ./figures/fig_pricelevel_n

for i=1:length(THETA_const(:,1)); thet_norm(i,:)=THETA_const(i,:)./delta_vec; end

figure(7)
plot(delta_vec,thet_norm,'-','LineWidth', 2);
lh=legend('$n=1 $','$n=2 $','$n=10 $','$n=30 $', 0);
%lh=legend('$\mathcal{F}_n$  ','$\Phi_n/\Phi_1$  Constant $N_a$ and $Std (\Delta p) \ \ \ \ \ \ $', 0);
set(lh, 'fontsize',18,'Interpreter','Latex');
%ti=title('ZOOM  Impact on  Price Level keeping $N_a$ constant'); 
% set(ti, 'fontsize',16,'Interpreter','Latex');
xl=xlabel('Size of shock  , $\delta$');
set(xl, 'fontsize',16,'Interpreter','Latex');
%axis([0 0.05 0  .02] )

